diff --git a/game/client/src/main/java/net/minecraft/client/gui/nbteditor/components/ArrayTagComponent.java b/game/client/src/main/java/net/minecraft/client/gui/nbteditor/components/ArrayTagComponent.java
new file mode 100644
index 000000000..c23eb9589
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/gui/nbteditor/components/ArrayTagComponent.java
@@ -0,0 +1,45 @@
+package net.minecraft.client.gui.nbteditor.components;
+
+import com.mojang.logging.LogUtils;
+import com.mojang.nbt.tags.Tag;
+import net.minecraft.client.gui.Screen;
+import net.minecraft.client.gui.popup.PopupBuilder;
+import net.minecraft.client.render.tessellator.Tessellator;
+import org.jetbrains.annotations.NotNull;
+import org.slf4j.Logger;
+
+import java.lang.reflect.Array;
+
+public abstract class ArrayTagComponent<T> extends AbstractTagComponent<T> {
+    private static final Logger LOGGER = LogUtils.getLogger();
+
+    public ArrayTagComponent(@NotNull Screen attachedScreen, @NotNull Tag<T> tag) {
+        super(attachedScreen, tag);
+    }
+
+    @Override
+    public void onMouseClick(int mx, int my, int mouseButton, float partialTick) {
+        if (isHovered(mx, my, partialTick)) {
+            if (mouseButton == 0) {
+                attachedScreen.mc.displayScreen(new PopupBuilder(attachedScreen, 400).withTextField("input", valueToString())
+                    .closeOnEsc(0)
+                    .closeOnEnter(0)
+                    .closeOnClickOut(0)
+                    .withOnCloseListener((statusCode, results) -> {
+                        if (statusCode == 0) {
+                            try {
+                                parseValueFromString((String) results.get("input"));
+                            } catch (Exception e) {
+                                LOGGER.error("Failed to parse input '{}' into a '{}'!", results.get("input"), this.tag.getClass().getSimpleName(), e);
+                            }
+                        }
+                    })
+                    .build());
+            }
+        }
+    }
+
+    public abstract @NotNull String valueToString();
+
+    public abstract void parseValueFromString(@NotNull String valueString) throws Exception;
+}
diff --git a/game/client/src/main/java/net/minecraft/client/gui/nbteditor/components/ByteArrayTagComponent.java b/game/client/src/main/java/net/minecraft/client/gui/nbteditor/components/ByteArrayTagComponent.java
new file mode 100644
index 000000000..2c117f799
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/gui/nbteditor/components/ByteArrayTagComponent.java
@@ -0,0 +1,59 @@
+package net.minecraft.client.gui.nbteditor.components;
+
+import com.mojang.logging.LogUtils;
+import com.mojang.nbt.tags.ByteArrayTag;
+import net.minecraft.client.gui.Screen;
+import net.minecraft.client.gui.popup.PopupBuilder;
+import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
+import net.minecraft.core.util.helper.DyeColor;
+import org.jetbrains.annotations.NotNull;
+import org.slf4j.Logger;
+
+public class ByteArrayTagComponent extends ArrayTagComponent<byte[]> {
+    public static final @NotNull IconCoordinate icon = TextureRegistry.getTexture("minecraft:gui/screen/nbt/byte_array_tag");
+
+    public ByteArrayTagComponent(@NotNull Screen attachedScreen, @NotNull ByteArrayTag tag) {
+        super(attachedScreen, tag);
+
+    }
+
+    @Override
+    public void render(@NotNull Tessellator t, int offX, int offY, int mx, int my, float partialTick) {
+        super.render(t, offX, offY, mx, my, partialTick);
+        drawRect(offX + 12 + COMPONENT_PADDING, offY, offX + width(mx, my, partialTick), offY + height(mx, my, partialTick), isHovered(mx, my, partialTick) ? COLOR_BACKGROUND_HIGHLIGHTED : COLOR_BACKGROUND);
+        attachedScreen.fontRenderer.render(t, tag.getTagName(), offX + 12 + COMPONENT_PADDING + TEXT_PADDING, offY + TEXT_PADDING).setColor(DyeColor.YELLOW.color).call();
+        attachedScreen.fontRenderer.render(t, ": ", attachedScreen.fontRenderer.getLastEndingX(), offY + TEXT_PADDING).setColor(DyeColor.YELLOW.color).call();
+        attachedScreen.fontRenderer.render(t, this.tag.getValue().length, attachedScreen.fontRenderer.getLastEndingX(), offY + TEXT_PADDING).call();
+        attachedScreen.fontRenderer.render(t, " bytes", attachedScreen.fontRenderer.getLastEndingX(), offY + TEXT_PADDING).call();
+    }
+
+    @Override
+    public @NotNull IconCoordinate getIcon(int mx, int my, float partialTick) {
+        return icon;
+    }
+
+    @Override
+    public @NotNull String valueToString() {
+        StringBuilder builder = new StringBuilder();
+        byte[] bytes = this.tag.getValue();
+        for (int i = 0; i < bytes.length; i++) {
+            if (i != 0) {
+                builder.append(", ");
+            }
+            builder.append(bytes[i]);
+        }
+        return builder.toString();
+    }
+
+    @Override
+    public void parseValueFromString(@NotNull String valueString) throws Exception {
+        String[] split = valueString.replace(" ", "").split(",");
+        byte[] bytes = new byte[split.length];
+        for (int i = 0; i < split.length; i++) {
+            bytes[i] = Byte.parseByte(split[i]);
+        }
+        this.tag.setValue(bytes);
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/gui/nbteditor/components/ByteTagComponent.java b/game/client/src/main/java/net/minecraft/client/gui/nbteditor/components/ByteTagComponent.java
new file mode 100644
index 000000000..0f8d2f715
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/gui/nbteditor/components/ByteTagComponent.java
@@ -0,0 +1,25 @@
+package net.minecraft.client.gui.nbteditor.components;
+
+import com.mojang.nbt.tags.ByteTag;
+import net.minecraft.client.gui.Screen;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
+import org.jetbrains.annotations.NotNull;
+
+public class ByteTagComponent extends ValueTagComponent<Byte>{
+    public static final @NotNull IconCoordinate icon = TextureRegistry.getTexture("minecraft:gui/screen/nbt/byte_tag");
+
+    public ByteTagComponent(@NotNull Screen attachedScreen, @NotNull ByteTag tag) {
+        super(attachedScreen, tag);
+    }
+
+    @Override
+    public @NotNull IconCoordinate getIcon(int mx, int my, float partialTick) {
+        return icon;
+    }
+
+    @Override
+    public void parseValueFromString(@NotNull String valueString) {
+        this.tag.setValue(Byte.parseByte(valueString));
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/gui/nbteditor/components/CompoundTagComponent.java b/game/client/src/main/java/net/minecraft/client/gui/nbteditor/components/CompoundTagComponent.java
new file mode 100644
index 000000000..da7136917
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/gui/nbteditor/components/CompoundTagComponent.java
@@ -0,0 +1,109 @@
+package net.minecraft.client.gui.nbteditor.components;
+
+import com.mojang.nbt.tags.CompoundTag;
+import com.mojang.nbt.tags.Tag;
+import net.minecraft.client.gui.Screen;
+import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
+import net.minecraft.core.util.helper.DyeColor;
+import org.jetbrains.annotations.NotNull;
+
+import java.util.ArrayList;
+import java.util.List;
+import java.util.Map;
+
+public class CompoundTagComponent extends AbstractTagComponent<@NotNull Map<String, Tag<?>>> {
+    public static final @NotNull IconCoordinate icon = TextureRegistry.getTexture("minecraft:gui/screen/nbt/compound_tag");
+
+    public boolean expanded = false;
+    public final List<AbstractTagComponent<?>> components = new ArrayList<>();
+
+    public CompoundTagComponent(@NotNull Screen attachedScreen, @NotNull CompoundTag tag) {
+        super(attachedScreen, tag);
+
+        for (Tag<?> t : tag.getValue().values()) {
+            components.add(ArrayTagComponent.componentForTag(attachedScreen,t));
+        }
+    }
+
+    @Override
+    public @NotNull IconCoordinate getIcon(int mx, int my, float partialTick) {
+        return icon;
+    }
+
+    @Override
+    public void render(@NotNull Tessellator t, int offX, int offY, int mx, int my, float partialTick) {
+        super.render(t, offX, offY, mx, my, partialTick);
+        drawRect(offX + 12 + COMPONENT_PADDING, offY, offX + super.width(mx, my, partialTick), offY + super.height(mx, my, partialTick),
+            (mx >= 0 && mx <= super.width(mx, my, partialTick) && my >= 0 && my <= super.height(mx, my, partialTick)) ? COLOR_BACKGROUND_HIGHLIGHTED : COLOR_BACKGROUND);
+        attachedScreen.fontRenderer.render(t, tag.getTagName(), offX + 12 + COMPONENT_PADDING + TEXT_PADDING, offY + TEXT_PADDING).setColor(DyeColor.YELLOW.color).call();
+        attachedScreen.fontRenderer.render(t, ": ", attachedScreen.fontRenderer.getLastEndingX(), offY + TEXT_PADDING).setColor(DyeColor.YELLOW.color).call();
+        attachedScreen.fontRenderer.render(t, this.tag.getValue().size(), attachedScreen.fontRenderer.getLastEndingX(), offY + TEXT_PADDING).call();
+        attachedScreen.fontRenderer.render(t, " entries", attachedScreen.fontRenderer.getLastEndingX(), offY + TEXT_PADDING).call();
+
+        if (expanded) {
+            int y = offY + super.height(mx, my, partialTick) + COMPONENT_PADDING;
+            for (AbstractTagComponent component : components) {
+                drawLineHorizontal(offX + 6, offX + SHIFT_RIGHT - 2, y + 6, 0xFFFFFFFF);
+
+                component.render(t, offX + SHIFT_RIGHT, y, mx - SHIFT_RIGHT, my - y + offY, partialTick);
+                y += component.height(mx - SHIFT_RIGHT, my - y + offY, partialTick) + COMPONENT_PADDING;
+            }
+            drawLineVertical(offX + 6, offY + super.height(mx, my, partialTick), y - 6, 0xFFFFFFFF);
+        }
+    }
+
+    @Override
+    public int height(int mx, int my, float partialTick) {
+        if (expanded) {
+            int height = super.height(mx, my, partialTick);
+            for (AbstractTagComponent component : components) {
+                my -= component.height(mx - SHIFT_RIGHT, my, partialTick) + COMPONENT_PADDING;
+                height += component.height(mx - SHIFT_RIGHT, my, partialTick) + COMPONENT_PADDING;
+            }
+            return height;
+        }
+        return super.height(mx, my, partialTick);
+    }
+
+    @Override
+    public int width(int mx, int my, float partialTick) {
+        if (expanded) {
+            int width = super.width(mx, my, partialTick);
+            for (AbstractTagComponent component : components) {
+                my -= component.height(mx - SHIFT_RIGHT, my, partialTick) + COMPONENT_PADDING;
+                width = Math.max(width, component.width(mx - SHIFT_RIGHT, my, partialTick));
+            }
+            return width;
+        }
+        return super.width(mx, my, partialTick);
+    }
+
+    @Override
+    public void onMouseClick(int mx, int my, int mouseButton, float partialTick) {
+        if (mx >= 0 && mx <= super.width(mx, my, partialTick) && my >= 0 && my <= super.height(mx, my, partialTick)) {
+            if (mouseButton == 0) {
+                expanded = !expanded;
+            }
+        } else if (expanded) {
+            int y = my - super.height(mx, my, partialTick);
+            for (AbstractTagComponent component : components) {
+                component.onMouseClick(mx - SHIFT_RIGHT, y, mouseButton, partialTick);
+                y -= component.height(mx - SHIFT_RIGHT, y, partialTick) + COMPONENT_PADDING;
+            }
+        }
+    }
+
+    @Override
+    public void onMouseRelease(int mx, int my, int mouseButton, float partialTick) {
+        if (expanded) {
+            int y = my - super.height(mx, my, partialTick);
+            for (AbstractTagComponent component : components) {
+                component.onMouseRelease(mx - SHIFT_RIGHT, y, mouseButton, partialTick);
+                y -= component.height(mx - SHIFT_RIGHT, y, partialTick) + COMPONENT_PADDING;
+            }
+        }
+    }
+
+}
diff --git a/game/client/src/main/java/net/minecraft/client/gui/nbteditor/components/DoubleArrayTagComponent.java b/game/client/src/main/java/net/minecraft/client/gui/nbteditor/components/DoubleArrayTagComponent.java
new file mode 100644
index 000000000..591c9a606
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/gui/nbteditor/components/DoubleArrayTagComponent.java
@@ -0,0 +1,56 @@
+package net.minecraft.client.gui.nbteditor.components;
+
+import com.mojang.nbt.tags.DoubleArrayTag;
+import net.minecraft.client.gui.Screen;
+import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
+import net.minecraft.core.util.helper.DyeColor;
+import org.jetbrains.annotations.NotNull;
+
+public class DoubleArrayTagComponent extends ArrayTagComponent<double[]> {
+    public static final @NotNull IconCoordinate icon = TextureRegistry.getTexture("minecraft:gui/screen/nbt/double_array_tag");
+
+    public DoubleArrayTagComponent(@NotNull Screen attachedScreen, @NotNull DoubleArrayTag tag) {
+        super(attachedScreen, tag);
+    }
+
+    @Override
+    public @NotNull IconCoordinate getIcon(int mx, int my, float partialTick) {
+        return icon;
+    }
+
+    @Override
+    public void render(@NotNull Tessellator t, int offX, int offY, int mx, int my, float partialTick) {
+        super.render(t, offX, offY, mx, my, partialTick);
+        drawRect(offX + 12 + COMPONENT_PADDING, offY, offX + width(mx, my, partialTick), offY + height(mx, my, partialTick), isHovered(mx, my, partialTick) ? COLOR_BACKGROUND_HIGHLIGHTED : COLOR_BACKGROUND);
+        attachedScreen.fontRenderer.render(t, tag.getTagName(), offX + 12 + COMPONENT_PADDING + TEXT_PADDING, offY + TEXT_PADDING).setColor(DyeColor.YELLOW.color).call();
+        attachedScreen.fontRenderer.render(t, ": ", attachedScreen.fontRenderer.getLastEndingX(), offY + TEXT_PADDING).setColor(DyeColor.YELLOW.color).call();
+        attachedScreen.fontRenderer.render(t, this.tag.getValue().length, attachedScreen.fontRenderer.getLastEndingX(), offY + TEXT_PADDING).call();
+        attachedScreen.fontRenderer.render(t, " doubles", attachedScreen.fontRenderer.getLastEndingX(), offY + TEXT_PADDING).call();
+    }
+
+    @Override
+    public @NotNull String valueToString() {
+        StringBuilder builder = new StringBuilder();
+        double[] doubles = this.tag.getValue();
+        for (int i = 0; i < doubles.length; i++) {
+            if (i != 0) {
+                builder.append(", ");
+            }
+            builder.append(doubles[i]);
+        }
+        return builder.toString();
+    }
+
+    @Override
+    public void parseValueFromString(@NotNull String valueString) throws Exception {
+        String[] split = valueString.replace(" ", "").split(",");
+        double[] doubles = new double[split.length];
+        for (int i = 0; i < split.length; i++) {
+            doubles[i] = Double.parseDouble(split[i]);
+        }
+        this.tag.setValue(doubles);
+    }
+
+}
diff --git a/game/client/src/main/java/net/minecraft/client/gui/nbteditor/components/DoubleTagComponent.java b/game/client/src/main/java/net/minecraft/client/gui/nbteditor/components/DoubleTagComponent.java
new file mode 100644
index 000000000..804e13016
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/gui/nbteditor/components/DoubleTagComponent.java
@@ -0,0 +1,25 @@
+package net.minecraft.client.gui.nbteditor.components;
+
+import com.mojang.nbt.tags.DoubleTag;
+import net.minecraft.client.gui.Screen;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
+import org.jetbrains.annotations.NotNull;
+
+public class DoubleTagComponent extends ValueTagComponent<Double>{
+    public static final @NotNull IconCoordinate icon = TextureRegistry.getTexture("minecraft:gui/screen/nbt/double_tag");
+
+    public DoubleTagComponent(@NotNull Screen attachedScreen, @NotNull DoubleTag tag) {
+        super(attachedScreen, tag);
+    }
+
+    @Override
+    public @NotNull IconCoordinate getIcon(int mx, int my, float partialTick) {
+        return icon;
+    }
+
+    @Override
+    public void parseValueFromString(@NotNull String valueString) {
+        this.tag.setValue(Double.parseDouble(valueString));
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/gui/nbteditor/components/FloatTagComponent.java b/game/client/src/main/java/net/minecraft/client/gui/nbteditor/components/FloatTagComponent.java
new file mode 100644
index 000000000..5a8118603
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/gui/nbteditor/components/FloatTagComponent.java
@@ -0,0 +1,25 @@
+package net.minecraft.client.gui.nbteditor.components;
+
+import com.mojang.nbt.tags.FloatTag;
+import net.minecraft.client.gui.Screen;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
+import org.jetbrains.annotations.NotNull;
+
+public class FloatTagComponent extends ValueTagComponent<Float> {
+    public static final @NotNull IconCoordinate icon = TextureRegistry.getTexture("minecraft:gui/screen/nbt/float_tag");
+
+    public FloatTagComponent(@NotNull Screen attachedScreen, @NotNull FloatTag tag) {
+        super(attachedScreen, tag);
+    }
+
+    @Override
+    public @NotNull IconCoordinate getIcon(int mx, int my, float partialTick) {
+        return icon;
+    }
+
+    @Override
+    public void parseValueFromString(@NotNull String valueString) {
+        this.tag.setValue(Float.parseFloat(valueString));
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/gui/nbteditor/components/IntTagComponent.java b/game/client/src/main/java/net/minecraft/client/gui/nbteditor/components/IntTagComponent.java
new file mode 100644
index 000000000..0621b7c75
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/gui/nbteditor/components/IntTagComponent.java
@@ -0,0 +1,25 @@
+package net.minecraft.client.gui.nbteditor.components;
+
+import com.mojang.nbt.tags.IntTag;
+import net.minecraft.client.gui.Screen;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
+import org.jetbrains.annotations.NotNull;
+
+public class IntTagComponent extends ValueTagComponent<Integer> {
+    public static final @NotNull IconCoordinate icon = TextureRegistry.getTexture("minecraft:gui/screen/nbt/int_tag");
+
+    public IntTagComponent(@NotNull Screen attachedScreen, @NotNull IntTag tag) {
+        super(attachedScreen, tag);
+    }
+
+    @Override
+    public @NotNull IconCoordinate getIcon(int mx, int my, float partialTick) {
+        return icon;
+    }
+
+    @Override
+    public void parseValueFromString(@NotNull String valueString) {
+        this.tag.setValue(Integer.parseInt(valueString));
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/gui/nbteditor/components/ListTagComponent.java b/game/client/src/main/java/net/minecraft/client/gui/nbteditor/components/ListTagComponent.java
new file mode 100644
index 000000000..fb4b281ca
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/gui/nbteditor/components/ListTagComponent.java
@@ -0,0 +1,107 @@
+package net.minecraft.client.gui.nbteditor.components;
+
+import com.mojang.nbt.tags.ListTag;
+import com.mojang.nbt.tags.Tag;
+import net.minecraft.client.gui.Screen;
+import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
+import net.minecraft.core.util.helper.DyeColor;
+import org.jetbrains.annotations.NotNull;
+
+import java.util.ArrayList;
+import java.util.List;
+
+public class ListTagComponent extends AbstractTagComponent<List<Tag<?>>>{
+    public static final @NotNull IconCoordinate icon = TextureRegistry.getTexture("minecraft:gui/screen/nbt/list_tag");
+
+    public boolean expanded = false;
+    public final List<AbstractTagComponent<?>> components = new ArrayList<>();
+
+    public ListTagComponent(@NotNull Screen attachedScreen, @NotNull ListTag tag) {
+        super(attachedScreen, tag);
+
+        for (Tag<?> t : tag) {
+            components.add(ArrayTagComponent.componentForTag(attachedScreen,t));
+        }
+    }
+
+    @Override
+    public @NotNull IconCoordinate getIcon(int mx, int my, float partialTick) {
+        return icon;
+    }
+
+    @Override
+    public void render(@NotNull Tessellator t, int offX, int offY, int mx, int my, float partialTick) {
+        super.render(t, offX, offY, mx, my, partialTick);
+        drawRect(offX + 12 + COMPONENT_PADDING, offY, offX + super.width(mx, my, partialTick), offY + super.height(mx, my, partialTick),
+            (mx >= 0 && mx <= super.width(mx, my, partialTick) && my >= 0 && my <= super.height(mx, my, partialTick)) ? COLOR_BACKGROUND_HIGHLIGHTED : COLOR_BACKGROUND);
+        attachedScreen.fontRenderer.render(t, tag.getTagName(), offX + 12 + COMPONENT_PADDING + TEXT_PADDING, offY + TEXT_PADDING).setColor(DyeColor.YELLOW.color).call();
+        attachedScreen.fontRenderer.render(t, ": ", attachedScreen.fontRenderer.getLastEndingX(), offY + TEXT_PADDING).setColor(DyeColor.YELLOW.color).call();
+        attachedScreen.fontRenderer.render(t, this.tag.getValue().size(), attachedScreen.fontRenderer.getLastEndingX(), offY + TEXT_PADDING).call();
+        attachedScreen.fontRenderer.render(t, " entries", attachedScreen.fontRenderer.getLastEndingX(), offY + TEXT_PADDING).call();
+
+        if (expanded) {
+            int y = offY + super.height(mx, my, partialTick) + COMPONENT_PADDING;
+            for (AbstractTagComponent component : components) {
+                drawLineHorizontal(offX + 6, offX + SHIFT_RIGHT - 2, y + 6, 0xFFFFFFFF);
+
+                component.render(t, offX + SHIFT_RIGHT, y, mx - SHIFT_RIGHT, my - y + offY, partialTick);
+                y += component.height(mx - SHIFT_RIGHT, my - y + offY, partialTick) + COMPONENT_PADDING;
+            }
+            drawLineVertical(offX + 6, offY + super.height(mx, my, partialTick), y - 6, 0xFFFFFFFF);
+        }
+    }
+
+    @Override
+    public int height(int mx, int my, float partialTick) {
+        if (expanded) {
+            int height = super.height(mx, my, partialTick);
+            for (AbstractTagComponent component : components) {
+                my -= component.height(mx - SHIFT_RIGHT, my, partialTick) + COMPONENT_PADDING;
+                height += component.height(mx - SHIFT_RIGHT, my, partialTick) + COMPONENT_PADDING;
+            }
+            return height;
+        }
+        return super.height(mx, my, partialTick);
+    }
+
+    @Override
+    public int width(int mx, int my, float partialTick) {
+        if (expanded) {
+            int width = super.width(mx, my, partialTick);
+            for (AbstractTagComponent component : components) {
+                my -= component.height(mx - SHIFT_RIGHT, my, partialTick) + COMPONENT_PADDING;
+                width = Math.max(width, component.width(mx - SHIFT_RIGHT, my, partialTick));
+            }
+            return width;
+        }
+        return super.width(mx, my, partialTick);
+    }
+
+    @Override
+    public void onMouseClick(int mx, int my, int mouseButton, float partialTick) {
+        if (mx >= 0 && mx <= super.width(mx, my, partialTick) && my >= 0 && my <= super.height(mx, my, partialTick)) {
+            if (mouseButton == 0) {
+                expanded = !expanded;
+            }
+        } else if (expanded) {
+            int y = my - super.height(mx, my, partialTick);
+            for (AbstractTagComponent component : components) {
+                component.onMouseClick(mx - SHIFT_RIGHT, y, mouseButton, partialTick);
+                y -= component.height(mx - SHIFT_RIGHT, y, partialTick) + COMPONENT_PADDING;
+            }
+        }
+    }
+
+    @Override
+    public void onMouseRelease(int mx, int my, int mouseButton, float partialTick) {
+        if (expanded) {
+            int y = my - super.height(mx, my, partialTick);
+            for (AbstractTagComponent component : components) {
+                component.onMouseRelease(mx - SHIFT_RIGHT, y, mouseButton, partialTick);
+                y -= component.height(mx - SHIFT_RIGHT, y, partialTick) + COMPONENT_PADDING;
+            }
+        }
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/gui/nbteditor/components/LongArrayTagComponent.java b/game/client/src/main/java/net/minecraft/client/gui/nbteditor/components/LongArrayTagComponent.java
new file mode 100644
index 000000000..12e9bbe14
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/gui/nbteditor/components/LongArrayTagComponent.java
@@ -0,0 +1,55 @@
+package net.minecraft.client.gui.nbteditor.components;
+
+import com.mojang.nbt.tags.LongArrayTag;
+import net.minecraft.client.gui.Screen;
+import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
+import net.minecraft.core.util.helper.DyeColor;
+import org.jetbrains.annotations.NotNull;
+
+public class LongArrayTagComponent extends ArrayTagComponent<long[]> {
+    public static final @NotNull IconCoordinate icon = TextureRegistry.getTexture("minecraft:gui/screen/nbt/long_array_tag");
+
+    public LongArrayTagComponent(@NotNull Screen attachedScreen, @NotNull LongArrayTag tag) {
+        super(attachedScreen, tag);
+    }
+
+    @Override
+    public @NotNull IconCoordinate getIcon(int mx, int my, float partialTick) {
+        return icon;
+    }
+
+    @Override
+    public void render(@NotNull Tessellator t, int offX, int offY, int mx, int my, float partialTick) {
+        super.render(t, offX, offY, mx, my, partialTick);
+        drawRect(offX + 12 + COMPONENT_PADDING, offY, offX + width(mx, my, partialTick), offY + height(mx, my, partialTick), isHovered(mx, my, partialTick) ? COLOR_BACKGROUND_HIGHLIGHTED : COLOR_BACKGROUND);
+        attachedScreen.fontRenderer.render(t, tag.getTagName(), offX + 12 + COMPONENT_PADDING + TEXT_PADDING, offY + TEXT_PADDING).setColor(DyeColor.YELLOW.color).call();
+        attachedScreen.fontRenderer.render(t, ": ", attachedScreen.fontRenderer.getLastEndingX(), offY + TEXT_PADDING).setColor(DyeColor.YELLOW.color).call();
+        attachedScreen.fontRenderer.render(t, this.tag.getValue().length, attachedScreen.fontRenderer.getLastEndingX(), offY + TEXT_PADDING).call();
+        attachedScreen.fontRenderer.render(t, " longs", attachedScreen.fontRenderer.getLastEndingX(), offY + TEXT_PADDING).call();
+    }
+
+    @Override
+    public @NotNull String valueToString() {
+        StringBuilder builder = new StringBuilder();
+        long[] longs = this.tag.getValue();
+        for (int i = 0; i < longs.length; i++) {
+            if (i != 0) {
+                builder.append(", ");
+            }
+            builder.append(longs[i]);
+        }
+        return builder.toString();
+    }
+
+    @Override
+    public void parseValueFromString(@NotNull String valueString) throws Exception {
+        String[] split = valueString.replace(" ", "").split(",");
+        long[] longs = new long[split.length];
+        for (int i = 0; i < split.length; i++) {
+            longs[i] = Long.parseLong(split[i]);
+        }
+        this.tag.setValue(longs);
+    }
+}
diff --git a/game/client/src/main/java/net/minecraft/client/gui/nbteditor/components/LongTagComponent.java b/game/client/src/main/java/net/minecraft/client/gui/nbteditor/components/LongTagComponent.java
new file mode 100644
index 000000000..ba88f5637
--- /dev/null
+++ b/game/client/src/main/java/net/minecraft/client/gui/nbteditor/components/LongTagComponent.java
@@ -0,0 +1,25 @@
+package net.minecraft.client.gui.nbteditor.components;
+
+import com.mojang.nbt.tags.LongTag;
+import net.minecraft.client.gui.Screen;
+import net.minecraft.client.render.texture.stitcher.IconCoordinate;
+import net.minecraft.client.render.texture.stitcher.TextureRegistry;
+import org.jetbrains.annotations.NotNull;
+
+public class LongTagComponent extends ValueTagComponent<Long> {
+    public static final @NotNull IconCoordinate icon = TextureRegistry.getTexture("minecraft:gui/screen/nbt/long_tag");
+
+    public LongTagComponent(@NotNull Screen attachedScreen, @NotNull LongTag tag) {
+        super(attachedScreen, tag);
+    }
+
+    @Override
+    public @NotNull IconCoordinate getIcon(int mx, int my, float partialTick) {
+        return icon;
+    }
+
+    @Override
+    public void parseValueFromString(@NotNull String valueString) {
+        this.tag.setValue(Long.parseLong(valueString));
+    }
+}
